
<!DOCTYPE html>


<html lang="en" data-content_root="../../" >

  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>Optimize graph &#8212; Eclipse Aidge  documentation</title>
  
  
  
  <script data-cfasync="false">
    document.documentElement.dataset.mode = localStorage.getItem("mode") || "";
    document.documentElement.dataset.theme = localStorage.getItem("theme") || "";
  </script>
  <!--
    this give us a css class that will be invisible only if js is disabled
  -->
  <noscript>
    <style>
      .pst-js-only { display: none !important; }

    </style>
  </noscript>
  
  <!-- Loaded before other Sphinx assets -->
  <link href="../../_static/styles/theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />
<link href="../../_static/styles/pydata-sphinx-theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />

    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=8f2a1f02" />
    <link rel="stylesheet" type="text/css" href="../../_static/graphviz.css?v=4ae1632d" />
    <link rel="stylesheet" type="text/css" href="../../_static/copybutton.css?v=76b2166b" />
    <link rel="stylesheet" type="text/css" href="../../_static/sg_gallery.css?v=d2d258e8" />
    <link rel="stylesheet" type="text/css" href="../../_static/sphinx-design.min.css?v=95c83b7e" />
    <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=794b2ffd" />
  
  <!-- So that users can add custom icons -->
  <script src="../../_static/scripts/fontawesome.js?digest=8878045cc6db502f8baf"></script>
  <!-- Pre-loaded scripts that we'll load fully later -->
  <link rel="preload" as="script" href="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf" />
<link rel="preload" as="script" href="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf" />

    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/clipboard.min.js?v=a7894cd8"></script>
    <script src="../../_static/copybutton.js?v=f281be69"></script>
    <script src="../../_static/design-tabs.js?v=f930bc37"></script>
    <script src="https://cdn.jsdelivr.net/npm/@jupyter-widgets/html-manager@^1.0.1/dist/embed-amd.js"></script>
    <script type="module" src="https://cdn.jsdelivr.net/npm/mermaid@10.3.0/dist/mermaid.esm.min.mjs"></script>
    <script type="module" src="https://cdn.jsdelivr.net/npm/@mermaid-js/layout-elk@0.1.4/dist/mermaid-layout-elk.esm.min.mjs"></script>
    <script type="module">import mermaid from "https://cdn.jsdelivr.net/npm/mermaid@10.3.0/dist/mermaid.esm.min.mjs";import elkLayouts from "https://cdn.jsdelivr.net/npm/@mermaid-js/layout-elk@0.1.4/dist/mermaid-layout-elk.esm.min.mjs";mermaid.registerLayoutLoaders(elkLayouts);mermaid.initialize({startOnLoad:false});</script>
    <script src="https://cdn.jsdelivr.net/npm/d3@7.9.0/dist/d3.min.js"></script>
    <script type="module">
import mermaid from "https://cdn.jsdelivr.net/npm/mermaid@10.3.0/dist/mermaid.esm.min.mjs";
window.addEventListener("load", () => mermaid.run());
</script>
    <script>DOCUMENTATION_OPTIONS.pagename = 'source/UserGuide/optimizeGraph';</script>
    <script>
        DOCUMENTATION_OPTIONS.theme_version = '0.16.1';
        DOCUMENTATION_OPTIONS.theme_switcher_json_url = 'https://eclipse-aidge.readthedocs.io/en/dev/_static/version_switcher.json';
        DOCUMENTATION_OPTIONS.theme_switcher_version_match = '0.5.0';
        DOCUMENTATION_OPTIONS.show_version_warning_banner =
            false;
        </script>
    <script src="../../_static/js/mermaid.min.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Perform an export" href="export.html" />
    <link rel="prev" title="Ensure robustness" href="ensureRobustness.html" />
  <meta name="viewport" content="width=device-width, initial-scale=1"/>
  <meta name="docsearch:language" content="en"/>
  <meta name="docsearch:version" content="0.5.0" />
  </head>
  
  
  <body data-bs-spy="scroll" data-bs-target=".bd-toc-nav" data-offset="180" data-bs-root-margin="0px 0px -60%" data-default-mode="">

  
  
  <div id="pst-skip-link" class="skip-link d-print-none"><a href="#main-content">Skip to main content</a></div>
  
  <div id="pst-scroll-pixel-helper"></div>
  
  <button type="button" class="btn rounded-pill" id="pst-back-to-top">
    <i class="fa-solid fa-arrow-up"></i>Back to top</button>

  
  <dialog id="pst-search-dialog">
    
<form class="bd-search d-flex align-items-center"
      action="../../search.html"
      method="get">
  <i class="fa-solid fa-magnifying-glass"></i>
  <input type="search"
         class="form-control"
         name="q"
         placeholder="Search the docs ..."
         aria-label="Search the docs ..."
         autocomplete="off"
         autocorrect="off"
         autocapitalize="off"
         spellcheck="false"/>
  <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd>K</kbd></span>
</form>
  </dialog>

  <div class="pst-async-banner-revealer d-none">
  <aside id="bd-header-version-warning" class="d-none d-print-none" aria-label="Version warning"></aside>
</div>

  
    <header class="bd-header navbar navbar-expand-lg bd-navbar d-print-none">
<div class="bd-header__inner bd-page-width">
  <button class="pst-navbar-icon sidebar-toggle primary-toggle" aria-label="Site navigation">
    <span class="fa-solid fa-bars"></span>
  </button>
  
  
  <div class="col-lg-3 navbar-header-items__start">
    
      <div class="navbar-item">

  
    
  

<a class="navbar-brand logo" href="../../index.html">
  
  
  
  
  
    
    
      
    
    
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-light" alt=""/>
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-dark pst-js-only" alt=""/>
  
  
    <p class="title logo__title">Eclipse Aidge</p>
  
</a></div>
    
      <div class="navbar-item">
<div class="version-switcher__container dropdown pst-js-only">
  <button id="pst-version-switcher-button-2"
    type="button"
    class="version-switcher__button btn btn-sm dropdown-toggle"
    data-bs-toggle="dropdown"
    aria-haspopup="listbox"
    aria-controls="pst-version-switcher-list-2"
    aria-label="Version switcher list"
  >
    Choose version  <!-- this text may get changed later by javascript -->
    <span class="caret"></span>
  </button>
  <div id="pst-version-switcher-list-2"
    class="version-switcher__menu dropdown-menu list-group-flush py-0"
    role="listbox" aria-labelledby="pst-version-switcher-button-2">
    <!-- dropdown will be populated by javascript on page load -->
  </div>
</div></div>
    
  </div>
  
  <div class="col-lg-9 navbar-header-items">
    
    <div class="me-auto navbar-header-items__center">
      
        <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
      
    </div>
    
    
    <div class="navbar-header-items__end">
      
        <div class="navbar-item navbar-persistent--container">
          

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
        </div>
      
      
        <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
      
        <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
      
    </div>
    
  </div>
  
  
    <div class="navbar-persistent--mobile">

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
    </div>
  

  
    <button class="pst-navbar-icon sidebar-toggle secondary-toggle" aria-label="On this page">
      <span class="fa-solid fa-outdent"></span>
    </button>
  
</div>

    </header>
  

  <div class="bd-container">
    <div class="bd-container__inner bd-page-width">
      
      
      
      <dialog id="pst-primary-sidebar-modal"></dialog>
      <div id="pst-primary-sidebar" class="bd-sidebar-primary bd-sidebar">
        

  
  <div class="sidebar-header-items sidebar-primary__section">
    
    
      <div class="sidebar-header-items__center">
        
          
          
            <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
          
        
      </div>
    
    
    
      <div class="sidebar-header-items__end">
        
          <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
        
          <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
        
      </div>
    
  </div>
  
    <div class="sidebar-primary-items__start sidebar-primary__section">
        <div class="sidebar-primary-item">
<nav class="bd-docs-nav bd-links"
     aria-label="Section Navigation">
  <p class="bd-links__title" role="heading" aria-level="1">Section Navigation</p>
  <div class="bd-toc-item navbar-nav"><ul class="current nav bd-sidenav">
<li class="toctree-l1"><a class="reference internal" href="architecture.html">Framework architecture</a></li>
<li class="toctree-l1"><a class="reference internal" href="data.html">Data</a></li>
<li class="toctree-l1"><a class="reference internal" href="modelGraph.html">Computational graph</a></li>
<li class="toctree-l1"><a class="reference internal" href="loadStoreModel.html">Load and store model</a></li>
<li class="toctree-l1"><a class="reference internal" href="interoperability.html">Plateform interoperability</a></li>
<li class="toctree-l1"><a class="reference internal" href="transformGraph.html">Transform graph</a></li>
<li class="toctree-l1"><a class="reference internal" href="staticAnalysis.html">Static analysis</a></li>
<li class="toctree-l1"><a class="reference internal" href="executeGraph.html">Runtime graph execution</a></li>
<li class="toctree-l1"><a class="reference internal" href="learnModel.html">Learn model</a></li>
<li class="toctree-l1"><a class="reference internal" href="benchmark.html">Benchmark neural network model</a></li>
<li class="toctree-l1"><a class="reference internal" href="ensureRobustness.html">Ensure robustness</a></li>
<li class="toctree-l1 current active"><a class="current reference internal" href="#">Optimize graph</a></li>
<li class="toctree-l1"><a class="reference internal" href="export.html">Perform an export</a></li>
<li class="toctree-l1"><a class="reference internal" href="learnEdge.html">Learn on edge</a></li>
</ul>
</div>
</nav></div>
    </div>
  
  
  <div class="sidebar-primary-items__end sidebar-primary__section">
      <div class="sidebar-primary-item">
<div id="ethical-ad-placement"
      class="flat"
      data-ea-publisher="readthedocs"
      data-ea-type="readthedocs-sidebar"
      data-ea-manual="true">
</div></div>
  </div>


      </div>
      
      <main id="main-content" class="bd-main" role="main">
        
        
          <div class="bd-content">
            <div class="bd-article-container">
              
              <div class="bd-header-article d-print-none">
<div class="header-article-items header-article__inner">
  
    <div class="header-article-items__start">
      
        <div class="header-article-item">

<nav aria-label="Breadcrumb" class="d-print-none">
  <ul class="bd-breadcrumbs">
    
    <li class="breadcrumb-item breadcrumb-home">
      <a href="../../index.html" class="nav-link" aria-label="Home">
        <i class="fa-solid fa-home"></i>
      </a>
    </li>
    
    <li class="breadcrumb-item"><a href="index.html" class="nav-link">User Guide</a></li>
    
    <li class="breadcrumb-item active" aria-current="page"><span class="ellipsis">Optimize graph</span></li>
  </ul>
</nav>
</div>
      
    </div>
  
  
</div>
</div>
              
              
              
                
<div id="searchbox"></div>
                <article class="bd-article">
                  
  <section id="optimize-graph">
<h1>Optimize graph<a class="headerlink" href="#optimize-graph" title="Link to this heading">#</a></h1>
<section id="change-topology-model-isomorphism">
<h2>Change topology (model isomorphism)<a class="headerlink" href="#change-topology-model-isomorphism" title="Link to this heading">#</a></h2>
<p>These optimizations update the topology of the computation graph however they do not change its mathematical properties (i.e. for the same output the model before and after optimization will provide the same result), that is what we call model isomorphism.</p>
<section id="fuse-matmul-added">
<h3>Fuse MatMul &amp; added<a class="headerlink" href="#fuse-matmul-added" title="Link to this heading">#</a></h3>
<p>ONNX graph can export <code class="docutils literal notranslate"><span class="pre">Dense</span></code> / <code class="docutils literal notranslate"><span class="pre">FC</span></code> operator as two <a class="reference internal" href="modelGraph.html#operator"><span class="std std-ref">operator</span></a>, <code class="docutils literal notranslate"><span class="pre">MatMul</span></code> and <code class="docutils literal notranslate"><span class="pre">Add</span></code>. This recipie replace these two operator and create a <code class="docutils literal notranslate"><span class="pre">FC</span></code> operator, reusing the Producers attached to the <code class="docutils literal notranslate"><span class="pre">MatMul</span></code> and <code class="docutils literal notranslate"><span class="pre">Add</span></code> operator.</p>
<img alt="../../_images/MatMulAddFuse.PNG" class="align-center" src="../../_images/MatMulAddFuse.PNG" />
</section>
<section id="tiling">
<h3>Tiling<a class="headerlink" href="#tiling" title="Link to this heading">#</a></h3>
<section id="proposed-implementation">
<h4>Proposed implementation<a class="headerlink" href="#proposed-implementation" title="Link to this heading">#</a></h4>
<p>Graph transformation:</p>
<figure class="align-center" id="id1">
<pre  class="mermaid">
        flowchart LR
    B(Before) -.-&gt; Conv(Conv) -.-&gt; After(After)
    </pre><figcaption>
<p><span class="caption-text">Before</span><a class="headerlink" href="#id1" title="Link to this image">#</a></p>
</figcaption>
</figure>
<figure class="align-center" id="id2">
<pre  class="mermaid">
        flowchart LR
    B(Before) -.- IN(( )) ----&gt; Stripe_1(Stripe_1) &amp; Stripe_2(Stripe_2) &amp; Stripe_3(Stripe_3) &amp; Stripe_4(Stripe_4) &amp; Stripe_5(Stripe_5)
    style IN fill:#000
    Stripe_1(Stripe_1) ----&gt; ConvStripe_1(ConvStripe_1)
    Stripe_2(Stripe_2) ----&gt; ConvStripe_2(ConvStripe_2)
    Stripe_3(Stripe_3) ----&gt; ConvStripe_3(ConvStripe_3)
    Stripe_4(Stripe_4) ----&gt; ConvStripe_4(ConvStripe_4)
    Stripe_5(Stripe_5) ----&gt; ConvStripe_5(ConvStripe_5)
    ConvStripe_1(ConvStripe_1) &amp; ConvStripe_2(ConvStripe_2) &amp; ConvStripe_3(ConvStripe_3) &amp; ConvStripe_4(ConvStripe_4) &amp; ConvStripe_5(ConvStripe_5) ----&gt; Unstripe(Unstripe)  -.-&gt; After(After)
    </pre><figcaption>
<p><span class="caption-text">After</span><a class="headerlink" href="#id2" title="Link to this image">#</a></p>
</figcaption>
</figure>
<p>Scheduling:</p>
<pre align="center" class="mermaid align-center">
        sequenceDiagram
    autonumber

    Stripe-&gt;&gt;ConvStripe: inputsReq = convLoadBufferIn()&lt;br/&gt;memTransferWait(inputsReq)&lt;br/&gt;inputsReq = convLoadBufferIn()
    ConvStripe-&gt;&gt;Unstripe: outputsReq = bufferToMemTransfer2D()
    Stripe-&gt;&gt;ConvStripe: memTransferWait(inputsReq)&lt;br/&gt;inputsReq = convLoadBufferIn()
    ConvStripe-&gt;&gt;Unstripe: memTransferWait(outputsReq)&lt;br/&gt;outputsReq = bufferToMemTransfer2D()
    Stripe-&gt;&gt;ConvStripe: memTransferWait(inputsReq)&lt;br/&gt;inputsReq = convLoadBufferIn()
    ConvStripe-&gt;&gt;Unstripe: memTransferWait(outputsReq)&lt;br/&gt;outputsReq = bufferToMemTransfer2D()
    Stripe-&gt;&gt;ConvStripe: memTransferWait(inputsReq)&lt;br/&gt;inputsReq = convLoadBufferIn()
    ConvStripe-&gt;&gt;Unstripe: memTransferWait(outputsReq)&lt;br/&gt;outputsReq = bufferToMemTransfer2D()
    Stripe-&gt;&gt;ConvStripe: memTransferWait(inputsReq)
    ConvStripe-&gt;&gt;Unstripe: memTransferWait(outputsReq)&lt;br/&gt;outputsReq = bufferToMemTransfer2D()&lt;br/&gt;memTransferWait(outputsReq)
    </pre><pre align="center" class="mermaid align-center">
        gantt
    dateFormat  s
    axisFormat %S
    title Scheduling

    Stripe_1           :crit, s1, 0, 2.05s
    Stripe_2           :s1b, after s1, 2s
    ConvStripe_1     :crit, c1, after s1, 3s
    Unstripe(1)         :crit, u1, after c1, 0.05s
    Unstripe(1)         :u1b, after u1, 1.5s
    Stripe_2           :crit, s2, after u1, 0.05s
    Stripe_3           :s2b, after s2, 2s
    ConvStripe_2     :crit, c2, after s2, 3s
    Unstripe(2)         :crit, u2, after c2, 0.05s
    Unstripe(2)         :u2b, after u2, 1.5s
    Stripe_3           :crit, s3, after u2, 0.05s
    Stripe_4           :s3b, after s3, 2s
    ConvStripe_3     :crit, c3, after s3, 3s
    Unstripe(3)         :crit, u3, after c3, 0.05s
    Unstripe(3)         :u3b, after u3, 1.5s
    Stripe_4           :crit, s4, after u3, 0.05s
    Stripe_5           :s4b, after s4, 2s
    ConvStripe_4     :crit, c4, after s4, 3s
    Unstripe(4)         :crit, u4, after c4, 0.05s
    Unstripe(4)         :u4b, after u4, 1.5s
    Stripe_5           :crit, s5, after u4, 0.05s
    ConvStripe_5     :crit, c5, after s5, 3s
    Unstripe(5)         :crit, u5, after c5, 1.55s
    </pre></section>
</section>
<section id="multi-layer-spatial-tiling">
<h3>Multi-layer spatial tiling<a class="headerlink" href="#multi-layer-spatial-tiling" title="Link to this heading">#</a></h3>
<p>Goal: tile spatially multiple layers.</p>
<p>Proposed method:</p>
<ol class="arabic simple">
<li><p>Specify the required tile’s position and size at some place in the block;</p></li>
<li><p>Propagate backward the required spatial tile’s position and size (with a mechanism similar to receptive field in N2D2);</p></li>
<li><p>Create the tiling operators and duplicate the subgraph.</p></li>
</ol>
<figure class="align-center" id="id3">
<pre  class="mermaid">
        flowchart LR
    B(Before) -.-&gt; Conv_1(Conv&lt;br&gt;3x3) ----&gt; ReLU_1(ReLU) ----&gt; Conv_2(Conv&lt;br&gt;1x1) ----&gt; ReLU_2(ReLU) ----&gt; Pad(Pad&lt;br&gt;1 1 1 1)  ----&gt; Conv_3(Conv&lt;br&gt;3x3) ----&gt; ReLU_3(ReLU)  -.-&gt; After(After)
    </pre><figcaption>
<p><span class="caption-text">Multiple layers tiling example</span><a class="headerlink" href="#id3" title="Link to this image">#</a></p>
</figcaption>
</figure>
<figure class="align-center" id="id4">
<pre  class="mermaid">
        flowchart LR
    B(Before) -. 50x50 .-&gt; Conv_1(Conv&lt;br&gt;3x3) ----&gt; ReLU_1(ReLU) -- 48x48 --&gt; Conv_2(Conv&lt;br&gt;1x1) ----&gt; ReLU_2(ReLU) -- 48x48 --&gt; Pad(Pad&lt;br&gt;1 1 1 1)  -- 50x50 --&gt; Conv_3(Conv&lt;br&gt;3x3) -- 48x48 --&gt; ReLU_3(ReLU)  -.-&gt; After(After)
    style Pad fill:#fbb
    </pre><figcaption>
<p><span class="caption-text">Initial dimensions</span><a class="headerlink" href="#id4" title="Link to this image">#</a></p>
</figcaption>
</figure>
<p>When computing tile sizes, <code class="docutils literal notranslate"><span class="pre">Pad</span></code> operators must be handled specifically. Only edge tiles should keep the padding corresponding to the position of the tile on edge.
An offset may be required on the final relative tile’s position and size to take into account dimensions reduction due to the convolution.</p>
<figure class="align-center" id="id5">
<pre  class="mermaid">
        flowchart LR
    B(Before) -. 50x50 .- branch(( ))
    branch -.-&gt; Tiling_0x0_19x19 -- -1x-1_18x18 --&gt; Conv_1_1(Conv&lt;br&gt;3x3) ----&gt; ReLU_1_1(ReLU) -- 0x0_17x17 --&gt; Conv_2_1(Conv&lt;br&gt;1x1) ----&gt; ReLU_2_1(ReLU) -- 0x0_17x17 --&gt; Pad_1(Pad&lt;br&gt;1 1 0 0)  -- -1x-1_17x17 --&gt; Conv_3_1(Conv&lt;br&gt;3x3) -- 0x0_16x16 --&gt; ReLU_3_1(ReLU)  -.-&gt; Untiling
    branch -.-&gt; Tiling_15x0_35x19 -- 14x-1_34x18 --&gt; Conv_1_2(Conv&lt;br&gt;3x3) ----&gt; ReLU_1_2(ReLU) -- 15x0_33x17 --&gt; Conv_2_2(Conv&lt;br&gt;1x1) ----&gt; ReLU_2_2(ReLU) -- 15x0_33x17 --&gt; Pad_2(Pad&lt;br&gt;1 0 0 0)  -- 15x-1_33x17 --&gt; Conv_3_2(Conv&lt;br&gt;3x3) -- 16x0_32x16 --&gt; ReLU_3_2(ReLU)  -.-&gt; Untiling
    branch -.-&gt; Tiling_31x0_50x19 -- 30x-1_49x18 --&gt; Conv_1_3(Conv&lt;br&gt;3x3) ----&gt; ReLU_1_3(ReLU) -- 31x0_48x17 --&gt; Conv_2_3(Conv&lt;br&gt;1x1) ----&gt; ReLU_2_3(ReLU) -- 31x0_48x17 --&gt; Pad_3(Pad&lt;br&gt;1 0 0 1)  -- 31x-1_49x17 --&gt; Conv_3_3(Conv&lt;br&gt;3x3) -- 32x0_48x16 --&gt; ReLU_3_3(ReLU)  -.-&gt; Untiling
    branch -.-&gt; Tiling_0x15_19x35 -- -1x14_18x34 --&gt; Conv_1_4(Conv&lt;br&gt;3x3) ----&gt; ReLU_1_4(ReLU) -- 0x15_17x33 --&gt; Conv_2_4(Conv&lt;br&gt;1x1) ----&gt; ReLU_2_4(ReLU) -- 0x15_17x33 --&gt; Pad_4(Pad&lt;br&gt;0 1 0 0)  -- -1x15_17x33 --&gt; Conv_3_4(Conv&lt;br&gt;3x3) -- 0x16_16x32 --&gt; ReLU_3_4(ReLU)  -.-&gt; Untiling
    branch -.-&gt; Tiling_15x15_35x35 -- 14x14_34x34 --&gt; Conv_1_5(Conv&lt;br&gt;3x3) ----&gt; ReLU_1_5(ReLU) -- 15x15_33x33 --&gt; Conv_2_5(Conv&lt;br&gt;1x1) ----&gt; ReLU_2_5(ReLU) -- 15x15_33x33 --&gt; Pad_5(Pad&lt;br&gt;0 0 0 0)  -- 15x15_33x33 --&gt; Conv_3_5(Conv&lt;br&gt;3x3) -- 16x16_32x32 --&gt; ReLU_3_5(ReLU)  -.-&gt; Untiling
    branch -.-&gt; Tiling_31x15_50x35 -- 30x14_49x34 --&gt; Conv_1_6(Conv&lt;br&gt;3x3) ----&gt; ReLU_1_6(ReLU) -- 31x15_48x33 --&gt; Conv_2_6(Conv&lt;br&gt;1x1) ----&gt; ReLU_2_6(ReLU) -- 31x15_48x33 --&gt; Pad_6(Pad&lt;br&gt;0 0 0 1)  -- 31x15_49x33 --&gt; Conv_3_6(Conv&lt;br&gt;3x3) -- 32x16_48x32 --&gt; ReLU_3_6(ReLU)  -.-&gt; Untiling
    branch -.-&gt; Tiling_0x31_19x50 -- -1x30_18x49 --&gt; Conv_1_7(Conv&lt;br&gt;3x3) ----&gt; ReLU_1_7(ReLU) -- 0x31_17x48 --&gt; Conv_2_7(Conv&lt;br&gt;1x1) ----&gt; ReLU_2_7(ReLU) -- 0x31_17x48 --&gt; Pad_7(Pad&lt;br&gt;0 1 1 0)  -- -1x31_17x49 --&gt; Conv_3_7(Conv&lt;br&gt;3x3) -- 0x32_16x48 --&gt; ReLU_3_7(ReLU)  -.-&gt; Untiling
    branch -.-&gt; Tiling_15x31_35x50 -- 14x30_34x49 --&gt; Conv_1_8(Conv&lt;br&gt;3x3) ----&gt; ReLU_1_8(ReLU) -- 15x31_33x48 --&gt; Conv_2_8(Conv&lt;br&gt;1x1) ----&gt; ReLU_2_8(ReLU) -- 15x31_33x48 --&gt; Pad_8(Pad&lt;br&gt;0 0 1 0)  -- 15x31_33x49 --&gt; Conv_3_8(Conv&lt;br&gt;3x3) -- 16x32_32x48 --&gt; ReLU_3_8(ReLU)  -.-&gt; Untiling
    branch -.-&gt; Tiling_31x31_50x50 -- 30x30_49x49 --&gt; Conv_1_9(Conv&lt;br&gt;3x3) ----&gt; ReLU_1_9(ReLU) -- 31x31_48x48 --&gt; Conv_2_9(Conv&lt;br&gt;1x1) ----&gt; ReLU_2_9(ReLU) -- 31x31_48x48 --&gt; Pad_9(Pad&lt;br&gt;0 0 1 1)  -- 31x31_49x49 --&gt; Conv_3_9(Conv&lt;br&gt;3x3) -- 32x32_48x48 --&gt; ReLU_3_9(ReLU)  -.-&gt; Untiling
    Untiling -. 48x48 .-&gt; After(After)
    style Pad_1 fill:#fbb
    style Pad_2 fill:#fbb
    style Pad_3 fill:#fbb
    style Pad_4 fill:#fbb
    style Pad_5 fill:#f00
    style Pad_6 fill:#fbb
    style Pad_7 fill:#fbb
    style Pad_8 fill:#fbb
    style Pad_9 fill:#fbb
    style branch fill:#000
    </pre><figcaption>
<p><span class="caption-text">Tile size computation</span><a class="headerlink" href="#id5" title="Link to this image">#</a></p>
</figcaption>
</figure>
</section>
</section>
</section>


                </article>
              
              
              
              
              
                <footer class="prev-next-footer d-print-none">
                  
<div class="prev-next-area">
    <a class="left-prev"
       href="ensureRobustness.html"
       title="previous page">
      <i class="fa-solid fa-angle-left"></i>
      <div class="prev-next-info">
        <p class="prev-next-subtitle">previous</p>
        <p class="prev-next-title">Ensure robustness</p>
      </div>
    </a>
    <a class="right-next"
       href="export.html"
       title="next page">
      <div class="prev-next-info">
        <p class="prev-next-subtitle">next</p>
        <p class="prev-next-title">Perform an export</p>
      </div>
      <i class="fa-solid fa-angle-right"></i>
    </a>
</div>
                </footer>
              
            </div>
            
            
              
                <dialog id="pst-secondary-sidebar-modal"></dialog>
                <div id="pst-secondary-sidebar" class="bd-sidebar-secondary bd-toc"><div class="sidebar-secondary-items sidebar-secondary__inner">


  <div class="sidebar-secondary-item">
<div
    id="pst-page-navigation-heading-2"
    class="page-toc tocsection onthispage">
    <i class="fa-solid fa-list"></i> On this page
  </div>
  <nav class="bd-toc-nav page-toc" aria-labelledby="pst-page-navigation-heading-2">
    <ul class="visible nav section-nav flex-column">
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#change-topology-model-isomorphism">Change topology (model isomorphism)</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#fuse-matmul-added">Fuse MatMul &amp; added</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#tiling">Tiling</a><ul class="visible nav section-nav flex-column">
<li class="toc-h4 nav-item toc-entry"><a class="reference internal nav-link" href="#proposed-implementation">Proposed implementation</a></li>
</ul>
</li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#multi-layer-spatial-tiling">Multi-layer spatial tiling</a></li>
</ul>
</li>
</ul>
  </nav></div>

  <div class="sidebar-secondary-item">

  
  <div class="tocsection editthispage">
    <a href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/edit/master/docs/source/UserGuide/optimizeGraph.rst">
      <i class="fa-solid fa-pencil"></i>
      
      
        
          Edit on GitLab
        
      
    </a>
  </div>
</div>

  <div class="sidebar-secondary-item">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../../_sources/source/UserGuide/optimizeGraph.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div></div>

</div></div>
              
            
          </div>
          <footer class="bd-footer-content">
            
          </footer>
        
      </main>
    </div>
  </div>
  
  <!-- Scripts loaded after <body> so the DOM is not blocked -->
  <script defer src="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf"></script>
<script defer src="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf"></script>

  <footer class="bd-footer">
<div class="bd-footer__inner bd-page-width">
  
    <div class="footer-items__start">
      
        <div class="footer-item">

  <p class="copyright">
    
      © Copyright 2023, CEA LIST.
      <br/>
    
  </p>
</div>
      
        <div class="footer-item">

  <p class="sphinx-version">
    Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 8.1.3.
    <br/>
  </p>
</div>
      
    </div>
  
  
  
    <div class="footer-items__end">
      
        <div class="footer-item">
<p class="theme-version">
  <!-- # L10n: Setting the PST URL as an argument as this does not need to be localized -->
  Built with the <a href="https://pydata-sphinx-theme.readthedocs.io/en/stable/index.html">PyData Sphinx Theme</a> 0.16.1.
</p></div>
      
    </div>
  
</div>

  </footer>
  </body>
</html>